
#include "DHT22.h"

#define HAVE_DHT22_SENSOR      1
#define HAVE_MOISTURE_SENSOR   0

#define DHT22_SENSOR_PIN       4
#define MOISTURE_SENSOR_PIN    A0

void setup() {
  Serial.begin(9600);
  delay(2000); // Recommended delay before sensor can be used
}

void sendDHT22ToXig(float temperature, float humidity) {
  Serial.print("idigi_data:names=temperature,humidity&values=");
  Serial.print(temperature, 1);
  Serial.print(",");
  Serial.print(humidity, 1);
  Serial.print("&units=C,RH\r\n");
}

void sendMoistureToXig(int moisture) {
  Serial.print("idigi_data:names=moisture&values=");
  Serial.print(moisture, DEC);
  Serial.print("\r\n");
}

void loop() {
  DHT22_Err_t result;
  float temperature = 0, humidity = 0;
  int moisture = 0;
  
  if (HAVE_DHT22_SENSOR) {
    result = getDHT22(DHT22_SENSOR_PIN, &temperature, &humidity);  
    if (result == DHT22_ERR_NONE) {
      sendDHT22ToXig(temperature, humidity);
    }
  }
  
  if (HAVE_MOISTURE_SENSOR) {
    moisture = analogRead(MOISTURE_SENSOR_PIN);
    sendMoistureToXig(moisture);
  }

  delay(5000);
}

